package  
{
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class Bomb extends Bullet 
	{
		public static const DAMAGE:int = 1;
		
		[Embed(source = "../assets/graphics/bomb.png")] 
		public static const BOMB:Class;
		
		public static const BULLET_SPEED:Number = 30.0;
		public static const LIFETIME:Number = 3.0;
		
		protected var m_velX:Number = 0.0;
		protected var m_velY:Number = 0.0;
		protected var m_lifeTimer:Number = 0.0;
		protected var m_spriteMap:Spritemap = null;
		
		public function Bomb(velX:Number, velY:Number) 
		{
			m_spriteMap = new Spritemap(BOMB, 16, 16);
			m_spriteMap.add("fuse", [0, 1], 10, true);
			m_spriteMap.play("fuse", false);
			
			graphic = m_spriteMap;
						
			m_velX = 0.0;
			m_velY = 0.0;
			
			collidable = false;
			
			setHitbox(16, 16);
			
			m_spriteMap.centerOrigin();
			
			m_damage = DAMAGE;
			m_removeOnHit = false;
		}
		
		override public function update():void 
		{
			m_lifeTimer += FP.elapsed;
			if (m_lifeTimer >= LIFETIME)
			{
				var explosion:Explosion = new Explosion();
				FP.world.add(explosion);
				explosion.Explode(x, y);
				explosion.SetOwner("bomb");
				
				FP.world.remove(this);
			}
						
			super.update();
		}
		
	}

}