package  
{
	import net.flashpunk.Sfx;
	import net.flashpunk.FP;
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class BombLauncher extends Weapon 
	{
		public static const FIRE_RATE:Number = 1.2;
		
		[Embed(source = "../assets/sfx/bomb.mp3")] 
		public static const SOUND:Class;
		
		protected var m_sound:Sfx = null;
		
		public function BombLauncher() 
		{
			m_fireRate = FIRE_RATE;
			m_fireRateTimer = FIRE_RATE;
			m_name = "BOMB LAUNCHER";
			
			m_sound = new Sfx(SOUND, null);
		}
		
		public override function SpawnBullet(playerX:int, playerY:int, targetX:int, targetY:int):void
		{
			if (m_fireRateTimer < m_fireRate )
			{
				return;
			}
			
			m_fireRateTimer = 0.0;
			
			var playerPos:Vector2D = new Vector2D(playerX, playerY);
			var velocity:Vector2D = new Vector2D(targetX, targetY);
			
			VMath.subtract(velocity, playerPos);
			VMath.normalize(velocity);
			VMath.multiply(velocity, LevelGraphics.LEVEL_GRID_SIZE);
						
			var bullet:Bomb = new Bomb(0, 0);
			bullet.x = (GameState.Player.x + 8) + velocity.x;
			bullet.y = (GameState.Player.y + 8) + velocity.y;
			
			m_sound.play();
						
			FP.world.add(bullet);
		}
	}

}