package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	import net.flashpunk.FP;
	
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class Cloud extends Entity 
	{
		public static const NUM_CLOUDS:int = 2;
		public static const SPEED_BASE:Number = 5.0;
		public static const SPEED_RANGE:Number = 15.0;
		
		[Embed(source = "../assets/graphics/cloud1.png")] 
		public static const CLOUD1:Class;
		
		[Embed(source = "../assets/graphics/cloud2.png")] 
		public static const CLOUD2:Class;
		
		protected var m_spriteMap:Spritemap = null;
		protected var m_cloudSpeed:Number = 0.0;
		
		public function Cloud() 
		{
			var clouds:Array = new Array(CLOUD1, CLOUD2);
			var cloudIdx:int = Math.floor(Math.random() * NUM_CLOUDS);
			
			m_spriteMap = new Spritemap(clouds[cloudIdx], 256, 128);
			m_spriteMap.alpha = 0.4;
			graphic = m_spriteMap;
			
			layer = -100; // foreground
			
			m_cloudSpeed = -(SPEED_BASE + Math.random() * SPEED_RANGE);
			
			type = "cloud";
		}
		
		public function IsCloudHalfGone():Boolean
		{
			return (x + (m_spriteMap.width / 2)) < 0;
		}
		
		public function IsCloudGone():Boolean
		{
			return (x + (m_spriteMap.width)) < 0;
		}
		
		override public function update():void 
		{
			x += m_cloudSpeed * FP.elapsed;
			
			super.update();
		}
	}

}