package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Emitter;
	import net.flashpunk.FP;
	import net.flashpunk.Sfx;
	import net.flashpunk.utils.Ease;
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class Explosion extends Entity
	{
		public static const DAMAGE:int = 20;
		public static const REMOVAL_DURATION:Number = 0.5;
		
		[Embed(source = "../assets/graphics/explosion.png")] 
		public static const EXPLOSION:Class;
		
		[Embed(source = "../assets/sfx/explode.mp3")] 
		public static const SOUND:Class;
		
		protected var m_emitter:Emitter = null;
		protected var m_exploded:Boolean = false;
		protected var m_removalTimer:Number = 0.0;
		protected var m_owner:String = "rocket";
		protected var m_explodeSound:Sfx = null;
		
		public function Explosion() 
		{
			layer = -1;
			
			type = "explosion";
			
			m_explodeSound = new Sfx(SOUND, null);
			
			m_emitter = new Emitter(EXPLOSION, 16, 16);
			m_emitter.newType("explosion", [0]);
			m_emitter.setAlpha("explosion", 1, 0)
			m_emitter.setMotion("explosion", 0, 10, 0.2, 360, 10, 0.1);
			m_emitter.relative = false;
			
			setHitbox(40, 40);
			
			graphic = m_emitter;
		}
		
		public function SetOwner(owner:String):void { m_owner = owner; }
		public function GetOwner():String { return m_owner; }
		
		public function Explode(_x:int, _y:int):void
		{
			x = _x;
			y = _y;
			
			for (var i:int = 0; i < 10; ++i)
			{
				m_emitter.emit("explosion", _x, _y);
			}
			m_exploded = true;
			
			m_explodeSound.play();
		}
		
		override public function update():void 
		{
			if (m_exploded)
			{
				m_removalTimer += FP.elapsed;
				if (m_removalTimer > REMOVAL_DURATION)
				{
					active = false;
					FP.world.remove(this);
				}
			}
			
			super.update();
		}
	}

}