package  
{
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Spritemap;
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class Flame extends Bullet 
	{
		public static const DAMAGE:int = 1;
		
		[Embed(source = "../assets/graphics/explosion.png")] 
		public static const EXPLOSION:Class;
		
		public static const BULLET_SPEED:Number = 30.0;
		public static const LIFETIME:Number = 1.3;
		
		protected var m_velX:Number = 0.0;
		protected var m_velY:Number = 0.0;
		protected var m_lifeTimer:Number = 0.0;
		protected var m_spriteMap:Spritemap = null;
		
		public function Flame(velX:Number, velY:Number) 
		{
			m_spriteMap = new Spritemap(EXPLOSION, 16, 16);
			graphic = m_spriteMap;
						
			m_velX = velX;
			m_velY = velY;
			
			if (velX < 0)
			{
				m_spriteMap.flipped = true;
			}
			
			setHitbox(16, 16);
			
			m_spriteMap.centerOrigin();
			
			m_damage = DAMAGE;
			m_removeOnHit = false;
		}
		
		override public function update():void 
		{
			m_lifeTimer += FP.elapsed;
			if (m_lifeTimer >= LIFETIME)
			{
				FP.world.remove(this);
			}
			
			m_spriteMap.alpha = (LIFETIME - m_lifeTimer) / LIFETIME;
			m_spriteMap.scale = 1.0 + (m_lifeTimer / LIFETIME) * 1.2;
			m_spriteMap.angle = ((LIFETIME - m_lifeTimer) / LIFETIME) * 45.0;
			
			x += m_velX * FP.elapsed;
			y += m_velY * FP.elapsed;
						
			super.update();
		}
		
	}

}