package  
{
	import flash.display.Bitmap;
	import flash.display.BitmapData;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Emitter;
	import net.flashpunk.FP;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.utils.Ease;
	
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class Gibs extends Entity 
	{
		public static const BLOOD_PARTICLES:int = 40;
		public static const REMOVAL_DURATION:Number = 3.0;
		
		protected var m_blood:BitmapData = null;
		protected var m_bloodEmitter:Emitter = null;
		protected var m_sprayed:Boolean = false;
		protected var m_removalTimer:Number = 0.0;
		
		public function Gibs() 
		{
			type = "blood";
			
			m_blood = new BitmapData(2, 2, false, 0xff0000);
			
			m_bloodEmitter = new Emitter(m_blood, 2, 2);
			m_bloodEmitter.newType("bloodspray", [0]);
			m_bloodEmitter.setAlpha("bloodspray", 1, 0, Ease.quadIn);
			m_bloodEmitter.setMotion("bloodspray", 0, 10, 0.2, 360, 10, 0.1);
			
			graphic = m_bloodEmitter;
		}
		
		public function BloodSpray(_x:int, _y:int):void
		{
			for (var i:int = 0; i < BLOOD_PARTICLES; ++i)
			{
				m_bloodEmitter.emit("bloodspray", _x, _y);
			}
			m_sprayed = true;
		}
		
		override public function update():void 
		{
			if (m_sprayed)
			{
				m_removalTimer += FP.elapsed;
				if (m_removalTimer > REMOVAL_DURATION)
				{
					FP.world.remove(this);
				}
			}
			
			super.update();
		}
	}

}