package  
{
	import net.flashpunk.FP;
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Spritemap;
	
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class Hobo extends Entity 
	{
		[Embed(source = "../assets/graphics/hobo.png")] 
		public static const HOBO_SPRITE:Class;
		
		public static const RUN_SPEED:Number = 200.0;
		
		protected var m_spriteMap:Spritemap = null;
		protected var m_running:Boolean = true;
		
		public function Hobo() 
		{
			type = "hobo";
			
			collidable = false;
			
			m_spriteMap = new Spritemap(HOBO_SPRITE, 16, 16, null);
			m_spriteMap.add("run", [0, 1], 10.0, true);
			m_spriteMap.play("run", false);
			
			graphic = m_spriteMap;
			
			x = -m_spriteMap.width;
			if (GameState.Player != null )
			{
				y = GameState.Player.y + 8;
			}
			
			layer = -5;
		}
		
		override public function update():void 
		{
			if (m_running)
			{
				x += RUN_SPEED * FP.elapsed;
				if (x > Main.SCREEN_WIDTH)
				{
					m_running = false;
					visible = false;
				}
			}
			
			super.update();
		}
		
		public function Run():void
		{
			x = -m_spriteMap.width;
			y = GameState.Player.y + 8;
			m_running = true;
			visible = true;
		}
	}

}