package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Tilemap;
	import flash.utils.ByteArray;
	import net.flashpunk.masks.Grid;
	
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class LevelGraphics extends Entity
	{
		public static const LEVEL_GRID_SIZE:int = 16;
		
		[Embed(source = "../assets/levels/graveyard.oel", mimeType = "application/octet-stream")]
		protected const GRAVEYARD_LEVEL:Class;
		
		[Embed(source = "../assets/graphics/environment.png")] 
		public static const GRAVEYARD_ENVIRONMENT:Class;
		
		protected var m_tiles:Tilemap;
		protected var m_collision:Grid;
		
		public function GetTiles():Tilemap
		{
			return m_tiles;
		}
		
		public function LevelGraphics() 
		{
			m_tiles = new Tilemap(GRAVEYARD_ENVIRONMENT, Main.SCREEN_WIDTH, Main.SCREEN_HEIGHT, LEVEL_GRID_SIZE, LEVEL_GRID_SIZE);
			layer = 10000; //bg
			
			m_collision = new Grid(Main.SCREEN_WIDTH, Main.SCREEN_HEIGHT, LEVEL_GRID_SIZE, LEVEL_GRID_SIZE, 0, 0);
			m_collision.setRect(0, 0, Main.SCREEN_WIDTH / LEVEL_GRID_SIZE, Main.SCREEN_HEIGHT / LEVEL_GRID_SIZE, false);
			
			mask = m_collision;
			
			graphic = m_tiles;
			
			type = "level";
		}
		
		
		public function LoadFromXML():void
		{
			var rawData:ByteArray = new GRAVEYARD_LEVEL;
			var xmlString:String = rawData.readUTFBytes(rawData.length);
			var xmlData:XML = new XML(xmlString);
			
			var xmlDataList:XMLList = xmlData.ground_under.tile;
			var xmlDataElement:XML;
			
			for each(xmlDataElement in xmlDataList)
			{
				m_tiles.setTile(xmlDataElement.@x / LEVEL_GRID_SIZE, xmlDataElement.@y / LEVEL_GRID_SIZE, GetTileIdx(xmlDataElement.@tx, xmlDataElement.@ty));
				//m_collision.setTile(xmlDataElement.@x / LEVEL_GRID_SIZE, xmlDataElement.@y / LEVEL_GRID_SIZE, GetTileIdx(xmlDataElement.@tx, xmlDataElement.@ty) != 1);
			}
			
			xmlDataList = xmlData.ground_above.tile;
			
			for each(xmlDataElement in xmlDataList)
			{
				m_tiles.setTile(xmlDataElement.@x / LEVEL_GRID_SIZE, xmlDataElement.@y / LEVEL_GRID_SIZE, GetTileIdx(xmlDataElement.@tx, xmlDataElement.@ty));
			}
			
			xmlDataList = xmlData.decor_solid.tile;
			
			for each(xmlDataElement in xmlDataList)
			{
				m_tiles.setTile(xmlDataElement.@x / LEVEL_GRID_SIZE, xmlDataElement.@y / LEVEL_GRID_SIZE, GetTileIdx(xmlDataElement.@tx, xmlDataElement.@ty));
				m_collision.setTile(xmlDataElement.@x / LEVEL_GRID_SIZE, xmlDataElement.@y / LEVEL_GRID_SIZE, GetTileIdx(xmlDataElement.@tx, xmlDataElement.@ty) == 4 || GetTileIdx(xmlDataElement.@tx, xmlDataElement.@ty) == 14);
			}
		}
		
		public static function GetTileIdx(tx:int, ty:int):int
		{
			return (ty / LEVEL_GRID_SIZE) * (3) + (tx / LEVEL_GRID_SIZE);
		}
	}

}