package 
{
	import net.flashpunk.Engine;
	import net.flashpunk.FP;
	import net.flashpunk.World;
	import net.flashpunk.utils.Input;
	import net.flashpunk.utils.Key;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class Main extends Engine 
	{
		public static const SCREEN_WIDTH:Number = 320;
		public static const SCREEN_WIDTH_HALF:Number = SCREEN_WIDTH / 2;
		public static const SCREEN_HEIGHT:Number = 240;
		
		protected var m_levelWorld:World = null;
		protected var m_level:Level = null;
		protected var m_titleScreenWorld:World = null;
		protected var m_titleScreen:TitleScreen = null;
		protected var m_scoreScreenWorld:World = null;
		protected var m_scoreScreen:ScoreScreen = null;
		protected var m_currentScene:Scene = null;
		
		public function Main():void 
		{
			if (siteLock())
			{
				super(SCREEN_WIDTH, SCREEN_HEIGHT, 30, false);
				FP.screen.scale = 2;
				
				m_levelWorld = new World();
				m_level = new Level(m_levelWorld);
				
				m_titleScreenWorld = new World();
				m_titleScreen = new TitleScreen(m_titleScreenWorld);
				
				m_scoreScreenWorld = new World();
				m_scoreScreen = new ScoreScreen(m_scoreScreenWorld);
				
				m_level.SetNextScene(m_scoreScreen);
				m_titleScreen.SetNextScene(m_level);
				m_scoreScreen.SetNextScene(m_level);
				
				FP.world = m_titleScreenWorld;
				m_titleScreen.Initialize();
								
				m_currentScene = m_titleScreen;
			}
		}
		
		override public function update():void 
		{
			if (m_currentScene.IsDone())
			{
				if (m_currentScene.GetNextScene() != null)
				{
					m_currentScene.GetWorld().removeAll();
					m_currentScene = m_currentScene.GetNextScene();
					FP.world = m_currentScene.GetWorld();
					m_currentScene.Initialize();
				}
			}
			else
			{
				m_currentScene.Update();
			}
			
			super.update();
		}
		
		protected function siteLock(): Boolean
		{
			var url:String=stage.loaderInfo.url;
			var urlStart:Number = url.indexOf("://")+3;
			var urlEnd:Number = url.indexOf("/", urlStart);
			var domain:String = url.substring(urlStart, urlEnd);
			var LastDot:Number = domain.lastIndexOf(".")-1;
			var domEnd:Number = domain.lastIndexOf(".", LastDot)+1;
			domain = domain.substring(domEnd, domain.length);
			if (domain != "roachpuppy.com" || domain != "squarespace.com") 
			{
				//return false;
			}
			
			return true;
		}
	}
	
}