package  
{
	import net.flashpunk.World;
	import net.flashpunk.utils.Input;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.graphics.Image;
	
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class ScoreScreen extends Scene
	{
		protected var m_levelGraphics:LevelGraphics = null;
		protected var m_deathLabel:Text = null;
		protected var m_scoreLabel:Text = null;
		protected var m_restartLabel:Text = null;
		protected var m_dialogBox:Image = null;
		
		public function ScoreScreen(world:World) 
		{
			m_world = world;
		}
		
		override public function Initialize():void 
		{
			m_levelGraphics = new LevelGraphics();
			m_world.add(m_levelGraphics);
			
			m_levelGraphics.LoadFromXML();
			
			m_dialogBox = Image.createRect(Main.SCREEN_WIDTH, Main.SCREEN_HEIGHT, 0x000000);
			m_dialogBox.alpha = 0.5;
			m_dialogBox.x = 0;
			m_dialogBox.y = 0;
			
			m_deathLabel = new Text(GameState.DeathReason);
			m_deathLabel.x = (Main.SCREEN_WIDTH / 2) - (m_deathLabel.width / 2);
			m_deathLabel.y = 20;
			
			m_scoreLabel = new Text("Final score: " + GameState.Score);
			m_scoreLabel.x = (Main.SCREEN_WIDTH / 2) - (m_scoreLabel.width / 2);
			m_scoreLabel.y = Main.SCREEN_HEIGHT / 2;
			
			m_restartLabel = new Text("Click to try again!");
			m_restartLabel.x = (Main.SCREEN_WIDTH / 2) - (m_restartLabel.width / 2);
			m_restartLabel.y = Main.SCREEN_HEIGHT - 40;
			
			m_world.addGraphic(m_dialogBox, -10000);
			m_world.addGraphic(m_deathLabel, -10001);
			m_world.addGraphic(m_scoreLabel, -10001);
			m_world.addGraphic(m_restartLabel, -10001);
						
			m_done = false;
		}
		
		override public function Update():void 
		{
			if (Input.mousePressed)
			{
				m_done = true;
			}
		}
	}

}