package  
{
	import net.flashpunk.FP;
	import net.flashpunk.Sfx;
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class Shotgun extends Weapon 
	{
		public static const FIRE_RATE:Number = 0.5;
		
		[Embed(source = "../assets/sfx/shotgun.mp3")] 
		public static const SOUND:Class;
		
		protected var m_sound:Sfx = null;
		
		public function Shotgun() 
		{
			m_fireRate = FIRE_RATE;
			m_fireRateTimer = FIRE_RATE;
			m_name = "SHOTGUN";
			
			m_sound = new Sfx(SOUND, null);
		}
		
		public override function SpawnBullet(playerX:int, playerY:int, targetX:int, targetY:int):void
		{
			if (m_fireRateTimer < m_fireRate )
			{
				return;
			}
			
			m_fireRateTimer = 0.0;
			
			var playerPos:Vector2D = new Vector2D(playerX, playerY);
			var velocity:Vector2D = new Vector2D(targetX, targetY);
			
			VMath.subtract(velocity, playerPos);
			VMath.normalize(velocity);
			VMath.multiply(velocity, ShotgunBullet.BULLET_SPEED);
			
			var bullet:ShotgunBullet = new ShotgunBullet(velocity.x, velocity.y);
			bullet.x = playerX;
			bullet.y = playerY;
			
			m_sound.play();
						
			FP.world.add(bullet);
		}
	}

}