package  
{
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Spritemap;
	
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class StandardZombie extends Zombie 
	{
		public static const ZOMBIE_WIDTH:int = 16;
		public static const ZOMBIE_HEIGHT:int = 16;
		public static const WALK_SPEED:Number = 10.0;
		public static const HEALTH:int = 20;
		public static const SCORE_VALUE:int = 10;
		
		[Embed(source = "../assets/graphics/stdzombie.png")] 
		public static const ZOMBIE_SPRITE:Class;
				
		public function StandardZombie() 
		{
			m_spriteMap = new Spritemap(ZOMBIE_SPRITE, ZOMBIE_WIDTH, ZOMBIE_HEIGHT, AnimationDone);
			
			m_spriteMap.add("walk", [0, 1, 2, 3], 1, true);
			m_spriteMap.add("rise", [4, 5, 6, 7, 8, 9], 4, false);
			m_spriteMap.play("rise");
			
			graphic = m_spriteMap;
			m_spawned = false;
			
			m_walkSpeed = WALK_SPEED;
			m_health = HEALTH;
			m_scoreValue = SCORE_VALUE;
			
			setHitbox(ZOMBIE_WIDTH, ZOMBIE_HEIGHT);
		}
		
		public function AnimationDone():void
		{
			m_spriteMap.play("walk");
			m_spawned = true;
		}
		
		override public function Die():void 
		{
			super.Die();
		}
	}

}