package  
{
	import net.flashpunk.World;
	import net.flashpunk.utils.Input;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.graphics.Image;
	
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class TitleScreen extends Scene
	{
		protected var m_levelGraphics:LevelGraphics = null;
		protected var m_titleLabel:Text = null;
		protected var m_copyrightLabel:Text = null;
		protected var m_descLabel:Text = null;
		protected var m_instLabel:Text = null;
		protected var m_dialogBox:Image = null;
		
		public function TitleScreen(world:World) 
		{
			m_world = world;
		}
		
		override public function Initialize():void 
		{
			m_levelGraphics = new LevelGraphics();
			m_world.add(m_levelGraphics);
			
			m_levelGraphics.LoadFromXML();
			
			m_dialogBox = Image.createRect(Main.SCREEN_WIDTH, Main.SCREEN_HEIGHT, 0x000000);
			m_dialogBox.alpha = 0.5;
			m_dialogBox.x = 0;
			m_dialogBox.y = 0;
			
			m_titleLabel = new Text("THANK YOU HOBO");
			m_titleLabel.x = (Main.SCREEN_WIDTH / 2) - (m_titleLabel.width);
			m_titleLabel.y = 20;
			m_titleLabel.scale = 2.0;
			
			m_descLabel = new Text("A 48 hour Ludum Dare game by Chris Zamanillo");
			m_descLabel.x = (Main.SCREEN_WIDTH / 2) - (m_descLabel.width / 4);
			m_descLabel.y = Main.SCREEN_HEIGHT / 3;
			m_descLabel.scale = 0.5;
			
			m_instLabel = new Text("WASD or arrow keys to move\nMouse to aim and shoot\n\n\nClick to begin");
			m_instLabel.x = (Main.SCREEN_WIDTH / 2) - (m_instLabel.width / 4);
			m_instLabel.y = Main.SCREEN_HEIGHT / 2;
			m_instLabel.scale = 0.5;
			
			m_copyrightLabel = new Text("Copyright 2011 Roach Puppy Games - http://roachpuppy.com");
			m_copyrightLabel.x = (Main.SCREEN_WIDTH / 2) - (m_copyrightLabel.width / 4);
			m_copyrightLabel.y = Main.SCREEN_HEIGHT - 20;
			m_copyrightLabel.scale = 0.5;
			
			m_world.addGraphic(m_dialogBox, -10000);
			m_world.addGraphic(m_titleLabel, -10001);
			m_world.addGraphic(m_descLabel, -10001);
			m_world.addGraphic(m_instLabel, -10001);
			m_world.addGraphic(m_copyrightLabel, -10001);
						
			m_done = false;
		}
		
		override public function Update():void 
		{
			if (Input.mousePressed)
			{
				m_done = true;
			}
		}
	}

}