package  
{
	import net.flashpunk.Entity;
	import net.flashpunk.graphics.Graphiclist;
	import net.flashpunk.graphics.Image;
	import net.flashpunk.graphics.Text;
	import net.flashpunk.FP;
	
	/**
	 * ...
	 * @author Chris Zamanillo
	 */
	public class UI extends Entity 
	{
		public static const DIALOG_DURATION:Number = 2.0;
		public static const NUM_QUOTES:int = 7;
		
		protected var m_scoreLabel:Text = null;
		protected var m_hoboTextLabel:Text = null;
		protected var m_dialogBox:Image = null;
		protected var m_showDialog:Boolean = true;
		protected var m_dialogTimer:Number = 0.0;
		protected var m_quotes:Array = new Array(NUM_QUOTES);
		
		public function UI() 
		{
			m_scoreLabel = new Text("Score: 000000000000000000", 1, 1, 0, 0);
			m_scoreLabel.text = "Score: 0";
			m_scoreLabel.scaleX = 0.5;
			m_scoreLabel.scaleY = 0.5;
			
			m_dialogBox = Image.createRect(175, 40, 0x000000);
			m_dialogBox.alpha = 0.5;
			m_dialogBox.x = (Main.SCREEN_WIDTH / 2) - (m_dialogBox.width / 2);
			m_dialogBox.y = Main.SCREEN_HEIGHT - m_dialogBox.height - 10;
			
			m_hoboTextLabel = new Text("It's dangerous to go alone,\ntake this MACHINE GUN!", m_dialogBox.x + 5, m_dialogBox.y + 5, (m_dialogBox.width - 10) * 2, (m_dialogBox.height - 10) * 2);
			m_hoboTextLabel.scaleX = 0.5;
			m_hoboTextLabel.scaleY = 0.5;
			
			graphic = new Graphiclist(m_scoreLabel, m_dialogBox, m_hoboTextLabel);
			
			layer = -100000; // foreground
			
			m_quotes[0] = "Wait wait, I promised that\none to my buddy,\ntake this ";
			m_quotes[1] = "No that won't do,\ntake this ";
			m_quotes[2] = "You scratched it!\nTake this ";
			m_quotes[3] = "Let me clean that\none for you,\ntake this ";
			m_quotes[4] = "You're holding it wrong,\ntake this ";
			m_quotes[5] = "Oh oh oh my turn!\nTake this ";
			m_quotes[6] = "Hey! Listen!\nTake this ";
		}
		
		override public function update():void 
		{
			m_scoreLabel.text = "Score: " + GameState.Score;
			
			m_hoboTextLabel.visible = m_showDialog;
			m_dialogBox.visible = m_showDialog;
			
			if (m_showDialog)
			{
				m_dialogTimer += FP.elapsed;
				m_dialogTimer = Math.min(m_dialogTimer, DIALOG_DURATION);
				if (m_dialogTimer >= DIALOG_DURATION)
				{
					m_showDialog = false;
					m_dialogTimer = 0.0;
				}
			}
			
			super.update();
		}
		
		public function ShowDialog(weaponName:String):void
		{
			var quoteIdx:int = Math.floor(Math.random() * NUM_QUOTES);
			m_hoboTextLabel.text = m_quotes[quoteIdx] + weaponName.toUpperCase() + "!"
			m_showDialog = true;
		}
	}

}